// Based on Shape Transform by Ira Greenberg. http://www.iragreenberg.com.

class Cylinder{
  
  int pts = 20; 
  float angle = 0;
  Point3D vertices[][];
  float radius;
  float cylinderLength;

  Cylinder(float radius, float cylinderLength){
    this.radius = radius;
    this.cylinderLength = cylinderLength;
  }

  void create(){


    // cylinder
    vertices = new Point3D[2][pts+1];

    // fill arrays
    for (int i=0; i<2; i++){
      angle = 0;
      for(int j=0; j<=pts; j++){
        vertices[i][j] = new Point3D();

        vertices[i][j].x = cos(radians(angle))*radius;
        vertices[i][j].y = sin(radians(angle))*radius;

        vertices[i][j].z = cylinderLength; 
        // the .0 after the 360 is critical
        angle+=360.0/pts;
      }
      cylinderLength*=-1;
    }

    // draw cylinder tube
    beginShape(QUAD_STRIP);
    for(int j=0; j<=pts; j++){
      vertex(vertices[0][j].x, vertices[0][j].y, vertices[0][j].z);
      vertex(vertices[1][j].x, vertices[1][j].y, vertices[1][j].z);
    }
    endShape();

    //draw cylinder ends
    for (int i=0; i<2; i++){
      beginShape();
      for(int j=0; j<pts; j++){
        vertex(vertices[i][j].x, vertices[i][j].y, vertices[i][j].z);
      }
      endShape(CLOSE);
    }
  }
}
