// Viral Blocks. 2007. by Diego Baca. 

import krister.Ess.*;

import processing.video.*;

import processing.opengl.*;

static public void main(String args[]) {
  PApplet.main(new String[] { 
    "--present", "Viral_Blocks"                                                                                   }
  );
}

//START OF "DECLARE VARIABLES"

//Splash
PImage splash;
int splashMillis = 0;

//Stop Button
int shelfSxpos;
ImageButtonsS stopButton;
ImageButtonsS stopFake;

//ACGT Variables
PImage Asplash;
PImage Csplash;
PImage Gsplash;
PImage Tsplash;

PImage[] newimage = new PImage[4];

int rab;
int rbb;
int rcb;
int rdb;
int reb;
int rfb;
int rgb;
int rhb;
int rib;

int lastsecond =0;

float spwhalf;
float sphhalf;
float spw;
float sph;

//MU Shelf
int shelfMUypos;
boolean MUshelfcheck = false;
int battLevel;
PImage arrow4;
PImage batt;

//AACalc
int cala;
int carg;
int casn;
int casp;
int ccys;
int cglu;
int cgln;
int cgly;
int chis;
int cile;
int cleu;
int clys;
int cmet;
int cphe;
int cpro;
int cser;
int cthr;
int ctrp;
int ctyr;
int cval;

//AA Shelf
int shelfAAypos;
boolean AAshelfcheck = false;
PImage ALA;
PImage ARG;
PImage ASN;
PImage ASP;
PImage CYS;
PImage GLN;
PImage GLU;
PImage GLY;
PImage HIS;
PImage ILE;
PImage LEU;
PImage LYS;
PImage MET;
PImage PHE;
PImage PRO;
PImage SER;
PImage THR;
PImage TRP;
PImage TYR;
PImage VAL;

PImage ALAO;
PImage ARGO;
PImage ASNO;
PImage ASPO;
PImage CYSO;
PImage GLNO;
PImage GLUO;
PImage GLYO;
PImage HISO;
PImage ILEO;
PImage LEUO;
PImage LYSO;
PImage METO;
PImage PHEO;
PImage PROO;
PImage SERO;
PImage THRO;
PImage TRPO;
PImage TYRO;
PImage VALO;

PImage ALAD;
PImage ARGD;
PImage ASND;
PImage ASPD;
PImage CYSD;
PImage GLND;
PImage GLUD;
PImage GLYD;
PImage HISD;
PImage ILED;
PImage LEUD;
PImage LYSD;
PImage METD;
PImage PHED;
PImage PROD;
PImage SERD;
PImage THRD;
PImage TRPD;
PImage TYRD;
PImage VALD;
PImage arrow3;
PImage arrow5;
PImage baseCnone;

//Shelf Tutorial
int shelfTUypos;
boolean TUshelfcheck = false;
PImage arrow;

//Shelf Genome
int shelfGEypos;
boolean GEshelfcheck = false;
PImage arrow2;

//Shelf Mag
int shelfMAypos;
boolean MAshelfcheck = false;
PImage arrow6;

//Movies
Movie movie1b;
Movie movie2b;
Movie movie3b;
Movie movie4b;
Movie movie5b;
Movie movieIb;

//Movie Sound Channel
AudioChannel movieA;
AudioChannel movieB;
AudioChannel movieC;
AudioChannel movieD;
AudioChannel movieE;
AudioChannel movieI;

//Fonts
PFont font;
PFont fontSmall;
PFont fontLarge;
PFont fontHuge;

//Colors
color morphology = color(0);
color envelopeColor = color(0);

//Buttons
static boolean changed=false;
static boolean changedB=false;
static boolean changedC=false;
static boolean changedD=false;
static boolean changedE=false;
static boolean changedS=false;

static int whichPressed=-3;
static int whichPressedB=0;
static int whichPressedC=0;
static int whichPressedD=1;
static int whichPressedE=0;
static int whichPressedS=0;

ImageButtons splashScreen;
ImageButtons intro;
ImageButtons introb;
ImageButtons unloader;
ImageButtons button;
ImageButtons button2;
ImageButtons button3;
ImageButtons button4;
ImageButtons button5;
ImageButtons button6;
ImageButtons button7;
ImageButtons button8;
ImageButtons button9;
ImageButtons button10;
ImageButtonsB fake;
ImageButtonsB buttonC10;
ImageButtonsB buttonC1;
ImageButtonsB buttonC2;
ImageButtonsB buttonC3;
ImageButtonsB buttonC4;
ImageButtonsB buttonC5;
ImageButtonsC fakeC;
ImageButtonsC mutate;
ImageButtonsD buttonD1;
ImageButtonsDb buttonD2;
ImageButtonsD buttonD3;
ImageButtonsD buttonD4;
ImageButtonsE fakeAA;
ImageButtonsE buttonALA;
ImageButtonsE buttonARG;
ImageButtonsE buttonASN;
ImageButtonsE buttonASP;
ImageButtonsE buttonCYS;
ImageButtonsE buttonGLN;
ImageButtonsE buttonGLU;
ImageButtonsE buttonGLY;
ImageButtonsE buttonHIS;
ImageButtonsE buttonILE;
ImageButtonsE buttonLEU;
ImageButtonsE buttonLYS;
ImageButtonsE buttonMET;
ImageButtonsE buttonPHE;
ImageButtonsE buttonPRO;
ImageButtonsE buttonSER;
ImageButtonsE buttonTHR;
ImageButtonsE buttonTRP;
ImageButtonsE buttonTYR;
ImageButtonsE buttonVAL;

//Envelope
int cuantos = 500;
Envelope[] envelope ;
float largo;
float[] z2 = new float[cuantos]; 
float[] phi = new float[cuantos]; 
float[] largos = new float[cuantos]; 

float rx = 0;
float ry =0;


// Bases Variables
String[] lines;
String link;
float total = 0;
float boundsTotal = 0;
float percentTotal = 0;
float[] counter = new float[64]; 
float[] alphaValue = new float[64];

//SHAPES
Cube cube;
Cylinder cylinder;
Icosahedral icosahedral;
float bounds = 0;

int cubies = 64;

createCodon[]d = new createCodon[cubies];

// controls CODON movement
float[] x = new float[cubies];
float[] y = new float[cubies];
float[] z = new float[cubies];
float[] xSpeed = new float[cubies];
float[] ySpeed = new float[cubies];
float[] zSpeed = new float[cubies];

// controls CODON rotation
float[] xRot = new float[cubies];
float[] yRot = new float[cubies];
float[] zRot = new float[cubies];

//END OF "DECLARE VARIABLES"

void setup(){
  size(screen.width, screen.height, OPENGL);
  background(0);
  frameRate(30);

  //Splash Image
  splash = loadImage("splash.gif");

  //Sound Library
  Ess.start(this);

  //ACTG Setup
  newimage[0] = loadImage("LettersA.png");
  newimage[1] = loadImage("LettersC.png");
  newimage[2] = loadImage("LettersG.png");
  newimage[3] = loadImage("LettersT.png");

  spwhalf = newimage[1].width/2;
  sphhalf = newimage[1].height/2;
  spw = newimage[1].width;
  sph = newimage[1].height;

  // FONT
  font = loadFont("UniversLTStd-Bold-12.vlw");
  fontSmall = loadFont("UniversLTStd-9.vlw");
  fontLarge = loadFont("UniversLTStd-Bold-14.vlw");
  fontHuge = loadFont("UniversLTStd-Bold-30.vlw");

  //Blocks
  ALA = loadImage("ALA.gif");
  ARG = loadImage("ARG.gif");
  ASN = loadImage("ASN.gif");
  ASP = loadImage("ASP.gif");
  CYS = loadImage("CYS.gif");
  GLN = loadImage("GLN.gif");
  GLU = loadImage("GLU.gif");
  GLY = loadImage("GLY.gif");
  HIS = loadImage("HIS.gif");
  ILE = loadImage("ILE.gif");
  LEU = loadImage("LEU.gif");
  LYS = loadImage("LYS.gif");
  MET = loadImage("MET.gif");
  PHE = loadImage("PHE.gif");
  PRO = loadImage("PRO.gif");
  SER = loadImage("SER.gif");
  THR = loadImage("THR.gif");
  TRP = loadImage("TRP.gif");
  TYR = loadImage("TYR.gif");
  VAL = loadImage("VAL.gif");

  ALAO = loadImage("ALAo.gif");
  ARGO = loadImage("ARGo.gif");
  ASNO = loadImage("ASNo.gif");
  ASPO = loadImage("ASPo.gif");
  CYSO = loadImage("CYSo.gif");
  GLNO = loadImage("GLNo.gif");
  GLUO = loadImage("GLUo.gif");
  GLYO = loadImage("GLYo.gif");
  HISO = loadImage("HISo.gif");
  ILEO = loadImage("ILEo.gif");
  LEUO = loadImage("LEUo.gif");
  LYSO = loadImage("LYSo.gif");
  METO = loadImage("METo.gif");
  PHEO = loadImage("PHEo.gif");
  PROO = loadImage("PROo.gif");
  SERO = loadImage("SERo.gif");
  THRO = loadImage("THRo.gif");
  TRPO = loadImage("TRPo.gif");
  TYRO = loadImage("TYRo.gif");
  VALO = loadImage("VALo.gif");

  ALAD = loadImage("ALAd.gif");
  ARGD = loadImage("ARGd.gif");
  ASND = loadImage("ASNd.gif");
  ASPD = loadImage("ASPd.gif");
  CYSD = loadImage("CYSd.gif");
  GLND = loadImage("GLNd.gif");
  GLUD = loadImage("GLUd.gif");
  GLYD = loadImage("GLYd.gif");
  HISD = loadImage("HISd.gif");
  ILED = loadImage("ILEd.gif");
  LEUD = loadImage("LEUd.gif");
  LYSD = loadImage("LYSd.gif");
  METD = loadImage("METd.gif");
  PHED = loadImage("PHEd.gif");
  PROD = loadImage("PROd.gif");
  SERD = loadImage("SERd.gif");
  THRD = loadImage("THRd.gif");
  TRPD = loadImage("TRPd.gif");
  TYRD = loadImage("TYRd.gif");
  VALD = loadImage("VALd.gif");

  //Arrows
  arrow =  loadImage("arrow.gif");
  arrow2 = loadImage("arrow2.gif");
  arrow3 = loadImage("arrow3.gif");
  arrow4 = loadImage("arrow4.gif");
  arrow5 = loadImage("arrow5.gif");
  arrow6 = loadImage("arrow6.gif");
  batt = loadImage("Batt.gif");

  //Buttons

  // Define and create image button
  PImage bb = loadImage("base.gif");
  PImage br = loadImage("roll.gif");
  PImage bd = loadImage("down.gif");
  PImage bs = loadImage("selected.gif");

  PImage bbc = loadImage("baseC.gif");
  PImage brc = loadImage("rollC.gif");
  PImage bdc = loadImage("downC.gif");
  PImage bsc = loadImage("selectedC.gif");
  PImage baseCnone = loadImage("baseCnone.gif");

  PImage cbc = loadImage("baseM.gif");
  PImage crc = loadImage("rollM.gif");
  PImage cdc = loadImage("downM.gif");
  PImage csc = loadImage("selectedM.gif");

  PImage dbc = loadImage("MagB.gif");
  PImage drc = loadImage("MagO.gif");
  PImage ddc = loadImage("MagD.gif");
  PImage dsc = loadImage("MagS.gif");
  PImage fff = loadImage("MagF.gif");

  PImage sbc = loadImage("stopO.gif");
  PImage src = loadImage("stopD.gif");
  PImage sdc = loadImage("stopB.gif");

  PImage black = loadImage("black.gif");

  //Stop Button
  int stopa1 = width/2-sbc.width/2;
  float stopb1  = height-80; 
  int stopc1 = sbc.width;
  int stopd1 = sbc.height;

  stopButton = new ImageButtonsS(stopa1, stopb1, stopc1, stopd1, sbc, src, sdc, sbc, 11);

  int stopa2 = -width;
  float stopb2 = 1.8*30; 
  int stopc2 = black.width;
  int stopd2 = black.height;

  stopFake = new ImageButtonsS(stopa2, stopb2, stopc2, stopd2, black, black, black, black, 0);

  //Amino Acid Buttons 

  int axm1 = -width - bb.width/2;
  float aym1 = height/17 - bb.height/2; 
  int awm1 = bb.width;
  int ahm1 = bb.height;

  fakeAA = new ImageButtonsE(axm1, aym1, awm1, ahm1, black, black, black, black, 0);

  int axm2 = 56+110;
  float aym2 = 1.8*30+shelfAAypos; 
  int awm2 = ALA.width;
  int ahm2 = ALA.height;

  buttonALA = new ImageButtonsE(axm2, aym2, awm2, ahm2, ALA, ALAO, ALAD, ALA, 1);

  int axm3 = 56+110;
  float aym3 = 2.8*30+shelfAAypos; 
  int awm3 = ALA.width;
  int ahm3 = ALA.height;

  buttonARG = new ImageButtonsE(axm3, aym3, awm3, ahm3, ARG, ARGO, ARGD, ARG, 2);

  int axm4 = 56+110;
  float aym4 = 3.8*30+shelfAAypos; 
  int awm4 = ALA.width;
  int ahm4 = ALA.height;

  buttonASN = new ImageButtonsE(axm4, aym4, awm4, ahm4, ASN, ASNO, ASND, ASN, 3);

  int axm5 = 56+110;
  float aym5 = 4.8*30+shelfAAypos; 
  int awm5 = ALA.width;
  int ahm5 = ALA.height;

  buttonASP = new ImageButtonsE(axm5, aym5, awm5, ahm5, ASP, ASPO, ASPD, ASP, 4);

  int axm6 = 56+110;
  float aym6 = 5.8*30+shelfAAypos; 
  int awm6 = ALA.width;
  int ahm6 = ALA.height;

  buttonCYS = new ImageButtonsE(axm6, aym6, awm6, ahm6, CYS, CYSO, CYSD, CYS, 5);

  int axm7 = 56+110;
  float aym7 = 6.8*30+shelfAAypos; 
  int awm7 = ALA.width;
  int ahm7 = ALA.height;

  buttonGLN = new ImageButtonsE(axm7, aym7, awm7, ahm7, GLN, GLNO, GLND, GLN, 6);

  int axm8 = 56+110;
  float aym8 = 7.8*30+shelfAAypos; 
  int awm8 = ALA.width;
  int ahm8 = ALA.height;

  buttonGLU = new ImageButtonsE(axm8, aym8, awm8, ahm8, GLU, GLUO, GLUD, GLU, 7);

  int axm9 = 56+110;
  float aym9 = 8.8*30+shelfAAypos; 
  int awm9 = ALA.width;
  int ahm9 = ALA.height;

  buttonGLY = new ImageButtonsE(axm9, aym9, awm9, ahm9, GLY, GLYO, GLYD, GLY, 8);

  int axm10 = 56+110;
  float aym10 =9.8*30+shelfAAypos; 
  int awm10 = ALA.width;
  int ahm10 = ALA.height;

  buttonHIS = new ImageButtonsE(axm10, aym10, awm10, ahm10, HIS, HISO, HISD, HIS, 9);

  int axm11 = 56+110;
  float aym11 = 10.8*30+shelfAAypos; 
  int awm11 = ALA.width;
  int ahm11 = ALA.height;

  buttonILE = new ImageButtonsE(axm11, aym11, awm11, ahm11, ILE, ILEO, ILED, ILE, 10);

  int axm12 = 56+110;
  float aym12 = 11.8*30+shelfAAypos; 
  int awm12 = ALA.width;
  int ahm12 = ALA.height;

  buttonLEU = new ImageButtonsE(axm12, aym12, awm12, ahm12, LEU, LEUO, LEUD, LEU, 11);

  int axm13 = 56+110;
  float aym13 = 12.8*30+shelfAAypos; 
  int awm13 = ALA.width;
  int ahm13 = ALA.height;

  buttonLYS = new ImageButtonsE(axm13, aym13, awm13, ahm13, LYS, LYSO, LYSD, LYS, 12);

  int axm14 = 56+110;
  float aym14 = 13.8*30+shelfAAypos; 
  int awm14 = ALA.width;
  int ahm14 = ALA.height;

  buttonMET = new ImageButtonsE(axm14, aym14, awm14, ahm14, MET, METO, METD, MET, 13);

  int axm15 = 56+110;
  float aym15 = 14.8*30+shelfAAypos; 
  int awm15 = ALA.width;
  int ahm15 = ALA.height;

  buttonPHE = new ImageButtonsE(axm15, aym15, awm15, ahm15, PHE, PHEO, PHED, PHE, 14);

  int axm16 = 56+110;
  float aym16 = 15.8*30+shelfAAypos; 
  int awm16 = ALA.width;
  int ahm16 = ALA.height;

  buttonPRO = new ImageButtonsE(axm16, aym16, awm16, ahm16, PRO, PROO, PROD, PRO, 15);

  int axm17 = 56+110;
  float aym17 = 16.8*30+shelfAAypos; 
  int awm17 = ALA.width;
  int ahm17 = ALA.height;

  buttonSER = new ImageButtonsE(axm17, aym17, awm17, ahm17, SER, SERO, SERD, SER, 16);

  int axm18 = 56+110;
  float aym18 = 17.8*30+shelfAAypos; 
  int awm18 = ALA.width;
  int ahm18 = ALA.height;

  buttonTHR = new ImageButtonsE(axm18, aym18, awm18, ahm18, THR, THRO, THRD, THR, 17);

  int axm19 = 56+110;
  float aym19 = 18.8*30+shelfAAypos; 
  int awm19 = ALA.width;
  int ahm19 = ALA.height;

  buttonTRP = new ImageButtonsE(axm19, aym19, awm19, ahm19, TRP, TRPO, TRPD, TRP, 18);

  int axm20 = 56+110;
  float aym20 = 19.8*30+shelfAAypos; 
  int awm20 = ALA.width;
  int ahm20 = ALA.height;

  buttonTYR = new ImageButtonsE(axm20, aym20, awm20, ahm20, TYR, TYRO, TYRD, TYR, 19);

  int axm21 = 56+110;
  float aym21 = 20.8*30+shelfAAypos; 
  int awm21 = ALA.width;
  int ahm21 = ALA.height;

  buttonVAL = new ImageButtonsE(axm21, aym21, awm21, ahm21, VAL, VALO, VALD, VAL, 20);

  //Mutate Buttons

  float bxm1 = -width - bb.width/2;
  int bym1 = height/17 - bb.height/2; 
  int bwm1 = bb.width;
  int bhm1 = bb.height;

  fakeC = new ImageButtonsC(bxm1, bym1, bwm1, bhm1, black, black, black, black, 0);

  float bxm2 = 48+185 - cbc.width/2;
  int bym2 = 3*30 - cbc.height/2; 
  int bwm2 = cbc.width;
  int bhm2 = cbc.height;

  mutate = new ImageButtonsC(bxm2, bym2, bwm2, bhm2, cbc, crc, cbc, csc, 1);

  //Virus Buttons
  int bxu4 = -width/60 - bb.width/2;
  int byu4 = height/17 - bb.height/2; 
  int bwu4 = bb.width;
  int bhu4 = bb.height;

  splashScreen = new ImageButtons(bxu4, byu4, bwu4, bhu4, black, black, black, black, -3);

  int bxu2 = -width/60 - bb.width/2;
  int byu2 = height/17 - bb.height/2; 
  int bwu2 = bb.width;
  int bhu2 = bb.height;

  intro = new ImageButtons(bxu2, byu2, bwu2, bhu2, black, black, black, black, -1);

  int bxu3 = -width/60 - bb.width/2;
  int byu3 = height/17 - bb.height/2; 
  int bwu3 = bb.width;
  int bhu3 = bb.height;

  introb = new ImageButtons(bxu3, byu3, bwu3, bhu3, black, black, black, black, -2);

  int bxu = -width/60 - bb.width/2;
  int byu = height/17 - bb.height/2; 
  int bwu = bb.width;
  int bhu = bb.height;

  unloader = new ImageButtons(bxu, byu, bwu, bhu, black, black, black, black, 0);

  int bx = 56+55 - bb.width/2;
  int by = 59+20 - bb.height/2; 
  int bw = bb.width;
  int bh = bb.height;

  button = new ImageButtons(bx, by, bw, bh, bb, br, bd, bs, 1);

  int bx2 = 56+55 - bb.width/2;
  int by2 = 2*59+20 - bb.height/2; 
  int bw2 = bb.width;
  int bh2 = bb.height;

  button2 = new ImageButtons(bx2, by2, bw2, bh2, bb, br, bd, bs, 2);

  int bx3 = 56+55 - bb.width/2;
  int by3 = 3*59+20 - bb.height/2; 
  int bw3 = bb.width;
  int bh3 = bb.height;

  button3 = new ImageButtons(bx3, by3, bw3, bh3, bb, br, bd, bs, 3);

  int bx4 = 56+55 - bb.width/2;
  int by4 = 4*59+20 - bb.height/2; 
  int bw4 = bb.width;
  int bh4 = bb.height;

  button4 = new ImageButtons(bx4, by4, bw4, bh4, bb, br, bd, bs, 4);

  int bx5 = 56+55 - bb.width/2;
  int by5 = 5*59+20 - bb.height/2; 
  int bw5 = bb.width;
  int bh5 = bb.height;

  button5 = new ImageButtons(bx5, by5, bw5, bh5, bb, br, bd, bs, 5);

  int bx6 = 56+55 - bb.width/2;
  int by6 = 6*59+20 - bb.height/2; 
  int bw6 = bb.width;
  int bh6 = bb.height;

  button6 = new ImageButtons(bx6, by6, bw6, bh6, bb, br, bd, bs, 6);

  int bx7 = 56+55 - bb.width/2;
  int by7 = 7*59+20 - bb.height/2; 
  int bw7 = bb.width;
  int bh7 = bb.height;

  button7 = new ImageButtons(bx7, by7, bw7, bh7, bb, br, bd, bs, 7);

  int bx8 = 56+55 - bb.width/2;
  int by8 = 8*59+20 - bb.height/2; 
  int bw8 = bb.width;
  int bh8 = bb.height;

  button8 = new ImageButtons(bx8, by8, bw8, bh8, bb, br, bd, bs, 8);

  int bx9 = 56+55 - bb.width/2;
  int by9 = 9*59+20 - bb.height/2; 
  int bw9 = bb.width;
  int bh9 = bb.height;

  button9 = new ImageButtons(bx9, by9, bw9, bh9, bb, br, bd, bs, 9);

  int bx10 = 56+55 - bb.width/2;
  int by10 = 10*59+20 - bb.height/2; 
  int bw10 = bb.width;
  int bh10 = bb.height;

  button10 = new ImageButtons(bx10, by10, bw10, bh10, bb, br, bd, bs, 10);

  //Camera Buttons

  int bxc0 = 58*width/60+10 - bb.width/2;
  int byc0 = -height/17 - bb.height/2; 
  int bwc0 = bb.width;
  int bhc0 = bb.height;

  fake = new ImageButtonsB(bxc0, byc0, bwc0, bhc0, black, black, black, black, 0);

  int bxc10 = 56+15 - bbc.width/2;
  int byc10 = 59+20 - bb.height/2; 
  int bwc10 = bb.width;
  int bhc10 = bb.height;

  buttonC10 = new ImageButtonsB(bxc10, byc10, bwc10, bhc10, bbc, brc, bdc, bsc, 10);

  int bxc1 = 56+15 - bbc.width/2;
  int byc1 = 2*59+20 - bb.height/2; 
  int bwc1 = bb.width;
  int bhc1 = bb.height;

  buttonC1 = new ImageButtonsB(bxc1, byc1, bwc1, bhc1, bbc, brc, bdc, bsc, 1);

  int bxc2 = 56+15 - bbc.width/2;
  int byc2 = 3*59+20  - bb.height/2; 
  int bwc2 = bb.width;
  int bhc2 = bb.height;

  buttonC2 = new ImageButtonsB(bxc2, byc2, bwc2, bhc2, bbc, brc, bdc, bsc, 2);

  int bxc3 = 56+15  - bbc.width/2;
  int byc3 = 4*59+20 - bb.height/2; 
  int bwc3 = bb.width;
  int bhc3 = bb.height;

  buttonC3 = new ImageButtonsB(bxc3, byc3, bwc3, bhc3, bbc, brc, bdc, bsc, 3);

  int bxc4 = 56+15  - bbc.width/2;
  int byc4 = 5*59+20 - bb.height/2; 
  int bwc4 = bb.width;
  int bhc4 = bb.height;

  buttonC4 = new ImageButtonsB(bxc4, byc4, bwc4, bhc4, bbc, brc, bdc, bsc, 4);


  int bxc5 = 56+15 - bbc.width/2;
  int byc5 = 6*59+20 - bb.height/2; 
  int bwc5 = bb.width;
  int bhc5 = bb.height;

  buttonC5 = new ImageButtonsB(bxc5, byc5, bwc5, bhc5, baseCnone, baseCnone, baseCnone, baseCnone, 9);


  //Mag Buttons
  int dxc1 = 120+30 - bbc.width/2;
  int dyc1 = 59+20 - bb.height/2; 
  int dwc1 = bb.width;
  int dhc1 = bb.height;

  buttonD1 = new ImageButtonsD(dxc1, dyc1, dwc1, dhc1, dbc, drc, ddc, dsc, 1);

  int dxc2 = 120+30 - bbc.width/2;
  int dyc2 = 2*59+20 - bb.height/2; 
  int dwc2 = bb.width;
  int dhc2 = bb.height;

  buttonD2 = new ImageButtonsDb(dxc2, dyc2, dwc2, dhc2, dbc, drc, ddc, dsc, fff, 2);

  int dxc3 = 120+30 - bbc.width/2;
  int dyc3 = 3*59+20 - bb.height/2; 
  int dwc3 = bb.width;
  int dhc3 = bb.height;

  buttonD3 = new ImageButtonsD(dxc3, dyc3, dwc3, dhc3, dbc, drc, ddc, dsc, 3);

  int dxc4 = 120+30 - bbc.width/2;
  int dyc4 = 4*59+20 - bb.height/2; 
  int dwc4 = bb.width;
  int dhc4 = bb.height;

  buttonD4 = new ImageButtonsD(dxc4, dyc4, dwc4, dhc4, dbc, drc, ddc, dsc, 4);


  //START OF "VarSETUP A" 

  //Load STRING/Virus
  String link = "HIV1.txt";
  lines = loadStrings(link);
  boundsTotal = lines[7].length();
  total = (lines[7].length())/3;
  bases();
  percentTotal = (total-counter[50]-counter[53]-counter[54]);
  AminoCalc();

  // instantiate CODON
  for (int i=0; i<cubies; i++){

    d[i] =  new createCodon();

    //initialize CODON position, speed and rotation
    x[i] = 0;
    y[i] = 0; 
    z[i] = 0;

    xSpeed[i] = random(-2, 2);
    ySpeed[i] = random(-2, 2); 
    zSpeed[i] = random(-2, 2); 

    xRot[i] = random(40, 100);
    yRot[i] = random(40, 100);
    zRot[i] = random(40, 100);
  }

  // size of external SHAPE
  bounds = pow(boundsTotal, .24)*61;


  // instantiate SHAPES
  cube =  new Cube(bounds, bounds, bounds);
  cylinder = new Cylinder((bounds*1.4)/2, bounds/2);
  icosahedral =  new Icosahedral(bounds*1.5, bounds*1.5, bounds*1.5);

  envelope = new Envelope[cuantos];
  for (int i=0; i<cuantos; i++){
    envelope[i] = new Envelope();
  }

  //END OF "VarSETUP A"

  //Movie Audio Channel Setup
  movieA = new AudioChannel("movieA.aif"); 
  movieB = new AudioChannel("movieB.aif"); 
  movieC = new AudioChannel("movieC.aif"); 
  movieD = new AudioChannel("movieD.aif"); 
  movieE = new AudioChannel("movieE.aif");
  movieI = new AudioChannel("movieI.aif"); 

  splashMillis = millis();
}

void draw(){

  if(whichPressed !=-1 && whichPressed !=-2){
    background(0);

  }

  if(whichPressed == -1 || whichPressed == -2){
    fill(0);
    rect(20,20,380,height);
    rect(width/2-500/2, 6*height/7-80/2, 500, 150);

  }

  //Stop Button Show
  if(whichPressedB != 0 && whichPressedB !=9){

    shelfSxpos = 0;
  }

  else{
    shelfSxpos = -width;
  }

  //Main Shelf
  fill(55);
  noStroke();
  rect(0, 0, width, 20);

  //Tutorial shelf check
  if(whichPressed !=-3){
    if(TUshelfcheck ==false){
      if((mouseX>40) && (mouseX<80) && (mouseY<20)){
        shelfTUypos = 0;
        TUshelfcheck = true;
        GEshelfcheck = false;
        AAshelfcheck = false;
        MUshelfcheck = false;
        MAshelfcheck = false;
      }
      else{
        shelfTUypos = -600;
      }
    }
    if(TUshelfcheck ==true){
      if((mouseX>40) && (mouseX<225+40) && (mouseY<410)){
        shelfTUypos = 0;
        GEshelfcheck = false;
        AAshelfcheck = false;
        MUshelfcheck = false;
        MAshelfcheck = false;
      }

      else{
        shelfTUypos = -600;
        TUshelfcheck = false;
      }
    }
  }
  else{
    shelfTUypos = -670;

  }

  //Tutorial Shelf
  fill(39);
  noStroke();
  rect(40, 20+shelfTUypos, 225, 390);
  image(arrow, 40, 0);



  //Genome Shelf Check
  if(whichPressed !=-3){
    if(GEshelfcheck ==false){
      if(mouseX>80 && mouseX<120 && mouseY<20){
        shelfGEypos = 0;
        GEshelfcheck = true;
        AAshelfcheck = false;
        TUshelfcheck = false;
        MUshelfcheck = false;
        MAshelfcheck = false;
      }
      else{
        shelfGEypos = -670;
      }
    }
    if(GEshelfcheck ==true){
      if((mouseX>80) && (mouseX<310+80) && (mouseY<650)){
        shelfGEypos = 0;
        AAshelfcheck = false;
        TUshelfcheck = false;
        MUshelfcheck = false;
        MAshelfcheck = false;
      }

      else{
        shelfGEypos = -670;
        GEshelfcheck = false;

      }
    }
  }
  else{
    shelfGEypos = -670;

  }


  //Genome Shelf
  fill(39);
  noStroke();
  rect(80, 20+shelfGEypos, 310, 630);
  image(arrow2, 80, 0);

  //Mag Shelf Check
  if(whichPressed != 0 && whichPressed !=-1 && whichPressed !=-2 && whichPressed !=-3){
    if(MAshelfcheck ==false){
      if((mouseX>120) && (mouseX<160) && mouseY<20){
        shelfMAypos = 0;
        MAshelfcheck = true;
        GEshelfcheck = false;
        TUshelfcheck = false;
        MUshelfcheck = false;
      }
      else{
        shelfMAypos = -670;
      }
    }
    if(MAshelfcheck ==true){
      if((mouseX>120) && (mouseX<160+120) && (mouseY<290)){
        shelfMAypos = 0;
        GEshelfcheck = false;
        TUshelfcheck = false;
        MUshelfcheck = false;
      }
      else{
        shelfMAypos = -670;
        MAshelfcheck = false;
      }
    }
  }
  else{
    shelfMAypos = -670;
    if((mouseX>120) && (mouseX<160) && mouseY<20){
      GEshelfcheck = false;
      TUshelfcheck = false;
      MUshelfcheck = false;

    }
  }

  //Mag Shelf
  fill(39);
  noStroke();
  rect(120, 20+shelfMAypos, 160, 270);
  if (whichPressed != 0 && whichPressed !=-1 && whichPressed !=-2 && whichPressed !=-3){
    image(arrow6, 120, 0);
  }
  else{
    image(arrow5, 120, 0);
  }

  //AA Shelf Check
  if(whichPressedD == 3){
    if(AAshelfcheck ==false){
      if((mouseX>160) && (mouseX<200) && mouseY<20){
        shelfAAypos = 0;
        AAshelfcheck = true;
        GEshelfcheck = false;
        TUshelfcheck = false;
        MUshelfcheck = false;
        MAshelfcheck = false;
      }
      else{
        shelfAAypos = -670;
      }
    }
    if(AAshelfcheck ==true){
      if((mouseX>160) && (mouseX<200+160) && (mouseY<670)){
        shelfAAypos = 0;
        GEshelfcheck = false;
        TUshelfcheck = false;
        MUshelfcheck = false;
        MAshelfcheck = false;
      }
      else{
        shelfAAypos = -670;
        AAshelfcheck = false;
      }
    }
  }
  else{
    shelfAAypos = -670;
    if((mouseX>160) && (mouseX<200) && mouseY<20){
      GEshelfcheck = false;
      TUshelfcheck = false;
      MUshelfcheck = false;
    }
  }

  //AA Shelf
  fill(39);
  noStroke();
  rect(160, 20+shelfAAypos, 200, 650);
  if (whichPressedD == 3){
    image(arrow3, 160, 0);
  }
  else{
    image(arrow5, 160, 0);
  }
  AAShelf();


  //Mutation Shelf Check
  if(whichPressedD == 5){
    if(MUshelfcheck ==false){
      if((mouseX>200) && (mouseX<6*width/42) && mouseY<20){
        shelfMUypos = 0;
        MUshelfcheck = true;
        GEshelfcheck = false;
        TUshelfcheck = false;
        AAshelfcheck = false;
        MAshelfcheck = false;
      }
      else{
        shelfMUypos = -670;
      }
    }
    if(MUshelfcheck ==true){
      if((mouseX>200) && (mouseX<320+width/42) && (mouseY<140)){
        shelfMUypos = 0;
        GEshelfcheck = false;
        TUshelfcheck = false;
        AAshelfcheck = false;
        MAshelfcheck = false;
      }
      else{
        shelfMUypos = -670;
        MUshelfcheck = false;
      }
    }
  }
  else{
    shelfMUypos = -670;
    if((mouseX>200) && (mouseX<6*width/42) && mouseY<20){
      GEshelfcheck = false;
      TUshelfcheck = false;
      AAshelfcheck = false;
    }
  }

  //Mutation Shelf
  fill(39);
  noStroke();
  rect(200, 20+shelfMUypos, 180, 120);
  if (whichPressedD == 5){
    image(arrow4, 200, 0);
  }
  else{
    image(arrow5, 200, 0);
  }
  /*
  image(batt, (440), 0+2);
   noStroke();
   
   if (battLevel<2375){
   fill(255,0,0,230);
   }
   else if(battLevel<4750){
   fill(255,255,0,230);
   }
   else if(battLevel>4750){
   fill(0,255,0,230);
   }
   
   rect(440+3.45, 5.5, 16.3*battLevel/9500, 8.3);
   */
  //Lables
  fill(255, 240);
  textFont(fontLarge, 14); 
  text("Select a Tutorial:",48, 36+5+shelfTUypos, 0);
  text("Select a Genome:", 48+40, 36+5+shelfGEypos, 0);
  text("Display:",48+80, 36+5+shelfMAypos, 0);
  text("Genome Composition:", 48+120, 36+5+shelfAAypos, 0);
  text("Mutate Genome:", 48+160, 36+5+shelfMUypos, 0);
  if(whichPressed == -1){
    textAlign(CENTER);
    fill(255,160);
    text("Rollover              and select 'Introduction' to begin.", width/2, 6*height/7, 0);
    image(arrow, width/2-106, 6*height/7-arrow.height+5);
  }

  textAlign(LEFT);
  fill(255, 150);
  textFont(font, 12); 

  //Viruses
  text("Human Immunodeficiency Virus 1", (2*48)+45, 59+20+shelfGEypos, 0);
  text("Hepatitis Delta Virus", (2*48)+45, 2*59+20+shelfGEypos, 0);
  text("Enterobacteria Phage T7", (2*48)+45, 3*59+20+shelfGEypos, 0);
  text("Helminthosporium Victoriae Virus 190S", (2*48)+45, 4*59+20+shelfGEypos, 0);
  text("Carrot Mottle Mimic Virus", (2*48)+45, 5*59+20+shelfGEypos, 0);
  text("Zaire Ebola Virus", (2*48)+45, 6*59+20+shelfGEypos, 0);
  text("Influenza A Virus H5N1", (2*48)+45, 7*59+20+shelfGEypos, 0);
  text("Tobacco Mosaic Virus", (2*48)+45, 8*59+20+shelfGEypos, 0);
  text("Measles Virus", (2*48)+45, 9*59+20+shelfGEypos, 0);
  text("Rabies Virus", (2*48)+45, 10*59+20+shelfGEypos, 0);


  //Tutorials
  text("Introduction", (2*48)+5, 59+20+shelfTUypos, 0);
  text("What is a virus?", (2*48)+5, 2*59+20+shelfTUypos, 0);
  text("Viral structures", (2*48)+5, 3*59+20+shelfTUypos, 0);
  text("Viral envelopes", (2*48)+5, 4*59+20+shelfTUypos, 0);
  text("Codons and Amino Acids", (2*48)+5, 5*59+20+shelfTUypos, 0);
  text("Genetic mutations", (2*48)+5, 6*59+20+shelfTUypos, 0);

  //Displays
  text("Capsid", (2*48)+85, 59+20+shelfMAypos, 0);
  text("Envelope", (2*48)+85, 2*59+20+shelfMAypos, 0);
  text("Codons", (2*48)+85, 3*59+20+shelfMAypos, 0);
  text("All elements", (2*48)+85, 4*59+20+shelfMAypos, 0);

  //Mutate
  text("Run mutation", 48+220, 3*30+shelfMUypos, 0);

  // Draw Buttons

  fake.update();
  fake.display();

  unloader.update();
  unloader.display();

  button.update();
  button.display();

  button2.update();
  button2.display();

  button3.update();
  button3.display();

  button4.update();
  button4.display();

  button5.update();
  button5.display();

  button6.update();
  button6.display();

  button7.update();
  button7.display();

  button8.update();
  button8.display();

  button9.update();
  button9.display();

  button10.update();
  button10.display();

  buttonC10.update();
  buttonC10.display();

  buttonC1.update();
  buttonC1.display();

  buttonC2.update();
  buttonC2.display();

  buttonC3.update();
  buttonC3.display();

  buttonC4.update();
  buttonC4.display();

  buttonC5.update();
  buttonC5.display();

  fake.update();
  fake.display();

  fakeC.update();
  fakeC.display();

  mutate.update();
  mutate.display();

  buttonD1.update();
  buttonD1.display();

  buttonD2.update();
  buttonD2.display();

  buttonD3.update();
  buttonD3.display();

  buttonD4.update();
  buttonD4.display();

  buttonALA.update();
  buttonALA.display();

  buttonARG.update();
  buttonARG.display();

  buttonASN.update();
  buttonASN.display();

  buttonASP.update();
  buttonASP.display();

  buttonCYS.update();
  buttonCYS.display();

  buttonGLN.update();
  buttonGLN.display();

  buttonGLU.update();
  buttonGLU.display();

  buttonGLY.update();
  buttonGLY.display();

  buttonHIS.update();
  buttonHIS.display();

  buttonILE.update();
  buttonILE.display();

  buttonLEU.update();
  buttonLEU.display();

  buttonLYS.update();
  buttonLYS.display();

  buttonMET.update();
  buttonMET.display();

  buttonPHE.update();
  buttonPHE.display();

  buttonPRO.update();
  buttonPRO.display();

  buttonSER.update();
  buttonSER.display();

  buttonTHR.update();
  buttonTHR.display();

  buttonTRP.update();
  buttonTRP.display();

  buttonTYR.update();
  buttonTYR.display();

  buttonVAL.update();
  buttonVAL.display();

  stopButton.update();
  stopButton.display();

  //Stop Buttons
  if(stopFake.id == whichPressedS){
    if(changedS){ 
      changedS=false; 
    }
  }

  if(stopButton.id == whichPressedS){
    if(changedS){ 
      changedS=false; 

      if(whichPressedB == 1){
        movieA.stop();
        movie1b.stop();
        whichPressedB = 0;
        whichPressedD = 1;
        whichPressedS = 0;
        whichPressed = -2;
      }
      else if(whichPressedB == 2){
        movieB.stop();
        movie2b.stop();
        whichPressedB = 0;
        whichPressedD = 1;
        whichPressedS = 0;
        whichPressed = -2;
      }
      else if(whichPressedB == 3){
        movieC.stop();
        movie3b.stop();
        whichPressedB = 0;
        whichPressedD = 1;
        whichPressedS = 0;
        whichPressed = -2;
      }
      else if(whichPressedB == 4){
        movieD.stop(); 
        movie4b.stop(); 
        whichPressedB = 0;
        whichPressedD = 1;
        whichPressedS = 0;
        whichPressed = -2;
      }
      else if(whichPressedB == 10){
        movieI.stop();
        movieIb.stop();
        whichPressedB = 0;
        whichPressedD = 1;
        whichPressedS = 0;
        whichPressed = -2;
      }
    }
  }


  //Mutate Buttons

  if(fakeC.id == whichPressedC){

  }

  if(mutate.id == whichPressedC){
  }

  //MOVIE BUTTONS

  //Movie Btn 1

  pushMatrix();

  if(fake.id == whichPressedB){
    if(changedB){ 
      changedB=false; 
    }
  }

  else if(buttonC10.id == whichPressedB){

    if(changedB){
      changedB=false;
      background(0);
      movieA.stop();
      movieB.stop();
      movieC.stop();
      movieD.stop(); 
      movieE.stop(); 
      movieI.stop();
      movieI.play(); 
      movieIb = new Movie(this, "movieIb.mov");
      movieIb.noLoop();

    }

    movieA.stop();
    movieB.stop();
    movieC.stop();
    movieD.stop(); 
    movieE.stop(); 
    if(movieIb.available()) {
      movieIb.read();
    }
    movieIb.play();
    noStroke();
    fill(0, 180);
    rect(0, 0, width, height);
    translate(0,0,400);
    //320, 240 original movie size
    image(movieIb, (width/2)-(320/2), height/2-(240/2));
    whichPressed = 0;


    if(movieIb.time()>31.90){
      background(0);
      whichPressedB = 0;
      whichPressedD = 1;
      whichPressed = -2;
    }
  }

  else if(buttonC1.id == whichPressedB){

    if(changedB){
      changedB=false;
      background(0);
      movieA.stop();
      movieB.stop();
      movieC.stop();
      movieD.stop(); 
      movieE.stop(); 
      movieI.stop();
      movieA.play(); 
      movie1b = new Movie(this, "movie1b.mov");
      movie1b.noLoop();
    }

    movieB.stop();
    movieC.stop();
    movieD.stop(); 
    movieE.stop(); 
    if(movie1b.available()) {
      movie1b.read();
    }
    movie1b.play();
    noStroke();
    fill(0, 180);
    rect(0, 0, width, height);
    translate(0,0,400);
    //320, 240 original movie size
    image(movie1b, (width/2)-(320/2), height/2-(240/2));
    whichPressed = 0;

    if(movie1b.time()>44.90){
      whichPressedB = 0;
      whichPressedD = 1;
      whichPressed = 1;
      varSetupA();
    }
  }

  else if(buttonC2.id == whichPressedB){

    if(changedB){
      changedB=false; 
      background(0);
      movieA.stop();
      movieB.stop();
      movieC.stop();
      movieD.stop(); 
      movieE.stop(); 
      movieI.stop();
      movieB.play(); 
      movie2b = new Movie(this, "movie2b.mov");
      movie2b.noLoop();
    }

    movieA.stop();
    movieC.stop();
    movieD.stop(); 
    movieE.stop(); 
    if(movie2b.available()) {
      movie2b.read();
    }
    movie2b.play();
    noStroke();
    fill(0, 180);
    rect(0, 0, width, height);
    translate(0,0,400);
    //320, 240 original movie size
    image(movie2b, (width/2)-(320/2), height/2-(240/2));
    whichPressed = 0;

    if(movie2b.time()>42.90){
      whichPressedB = 0;
      whichPressedD = 1;
      whichPressed = 1;
      varSetupA();
    }
  }

  else if(buttonC3.id == whichPressedB){

    if(changedB){
      changedB=false; 
      background(0);
      movieA.stop();
      movieB.stop();
      movieC.stop();
      movieD.stop(); 
      movieE.stop(); 
      movieI.stop();
      movieC.play(); 
      movie3b = new Movie(this, "movie3b.mov");
      movie3b.noLoop();
    }

    movieA.stop();
    movieB.stop();
    movieD.stop(); 
    movieE.stop(); 
    if(movie3b.available()) {
      movie3b.read();
    }
    movie3b.play();
    noStroke();
    fill(0, 180);
    rect(0, 0, width, height);
    translate(0,0,400);
    //320, 240 original movie size
    image(movie3b, (width/2)-(320/2), height/2-(240/2));
    whichPressed = 0;

    if(movie3b.time()>31.90){
      whichPressedB = 0;
      whichPressedD = 2;
      whichPressed = 1;
      varSetupA();
    }
  }

  else if(buttonC4.id == whichPressedB){

    if(changedB){
      changedB=false; 
      background(0);
      movieA.stop();
      movieB.stop();
      movieC.stop();
      movieD.stop(); 
      movieE.stop(); 
      movieI.stop();
      movieD.play(); 
      movie4b = new Movie(this, "movie4b.mov");
      movie4b.noLoop();
    }

    movieA.stop();
    movieB.stop();
    movieC.stop(); 
    movieE.stop();  
    if(movie4b.available()) {
      movie4b.read();
    }
    movie4b.play();
    noStroke();
    fill(0, 180);
    rect(0, 0, width, height);
    translate(0,0,400);
    //320, 240 original movie size
    image(movie4b, (width/2)-(320/2), height/2-(240/2));
    whichPressed = 0;

    if(movie4b.time()>84.90){
      whichPressedE = 0;
      whichPressedB = 0;
      whichPressedD = 3;
      whichPressed = 1;
      varSetupA();
    }
  }

  else if(buttonC5.id == whichPressedB){

    if(changedB){
      changedB=false; 
    }

  }


  /*
  else if(buttonC5.id == whichPressedB){
   
   if(changedB){
   changedB=false; 
   background(0);
   movieA.stop();
   movieB.stop();
   movieC.stop();
   movieD.stop(); 
   movieE.stop(); 
   movieI.stop();
   movieE.play(); 
   movie5b = new Movie(this, "movie5b.mov");
   movie5b.noLoop();
   }
   
   movieA.stop();
   movieB.stop();
   movieC.stop(); 
   movieD.stop(); 
   if(movie5b.available()) {
   movie5b.read();
   }
   movie5b.play();
   noStroke();
   fill(0, 180);
   rect(0, 0, width, height);
   translate(0,0,400);
   //320, 240 original movie size
   image(movie5b, (width/2)-(320/2), height/2-(240/2));
   whichPressed = 0;
   
   if(movie5b.time()>4.90){
   whichPressedE = 0;
   whichPressedB = 0;
   whichPressedD = 4;
   whichPressed = 1;
   varSetupA();
   }
   }
   */
  popMatrix();


  //Mag Buttons

  //Mag 1
  if(buttonD1.id == whichPressedD){

    if(changedD){ 
      changedD=false; 
      whichPressedE = 0;
    }

  }

  //Mag 2
  if(buttonD2.id == whichPressedD){

    if(changedD){ 
      changedD=false; 
      whichPressedE = 0;
    }

  }

  //Mag 3
  if(buttonD3.id == whichPressedD){

    if(changedD){ 
      changedD=false; 
      whichPressedE = 0;
    }

  }

  //Mag 4
  if(buttonD4.id == whichPressedD){

    if(changedD){ 
      changedD=false; 
      whichPressedE = 0;
    }

  }


  //Genome Buttons
  if(splashScreen.id == whichPressed){

    if(changed){ 
      changed=false; 
    }
    if(millis() <= splashMillis+3000){
      fill(0);
      rect(0,0,width, 20);
      pushMatrix();
      translate(0,0,-60);
      image(splash, width/2-splash.width/2, height/2-splash.height/2);
      popMatrix();
    }
    else{
      whichPressed = -1;
    }
  }

  if(intro.id == whichPressed){

    if(changed){ 
      changed=false; 
    }
    ACGT();
  }

  if(introb.id == whichPressed){

    if(changed){ 
      changed=false; 
    }

    ACGT();
  }


  if(unloader.id == whichPressed){

    if(changed){ 
      changed=false; 
    }

  }

  //VarSetup A
  if(button.id == whichPressed){

    if(changed){ 
      changed=false; 
      varSetupA();
      if(whichPressedE != 0){
        whichPressedD = 3;
        whichPressedE = 0;
      }

    }
    if(whichPressedD == 4){
      drawer(); 
    }
    else if(whichPressedD == 1){
      drawerJC();
    }
    else if(whichPressedD == 2){
      if(lines[5].equals ("True")){
        drawerJE();
      }
      else{
        textAlign(LEFT);
        fill(255, 100);
        textFont(fontHuge, 30); 
        text("Virus has no envelope.", width/2-160, height/2, 0);
      }
    }
    else if(whichPressedD == 3 && whichPressedE ==0){
      drawerJA();
    }
    else if(whichPressedD == 3 && whichPressedE ==1){
      drawerALA();
    }
    else if(whichPressedD == 3 && whichPressedE ==2){
      drawerARG();
    }
    else if(whichPressedD == 3 && whichPressedE ==3){
      drawerASN();
    }
    else if(whichPressedD == 3 && whichPressedE ==4){
      drawerASP();
    }
    else if(whichPressedD == 3 && whichPressedE ==5){
      drawerCYS();
    }
    else if(whichPressedD == 3 && whichPressedE ==6){
      drawerGLN();
    }
    else if(whichPressedD == 3 && whichPressedE ==7){
      drawerGLU();
    }
    else if(whichPressedD == 3 && whichPressedE ==8){
      drawerGLY();
    }
    else if(whichPressedD == 3 && whichPressedE ==9){
      drawerHIS();
    }
    else if(whichPressedD == 3 && whichPressedE ==10){
      drawerILE();
    }
    else if(whichPressedD == 3 && whichPressedE ==11){
      drawerLEU();
    }
    else if(whichPressedD == 3 && whichPressedE ==12){
      drawerLYS();
    }
    else if(whichPressedD == 3 && whichPressedE ==13){
      drawerMET();
    }
    else if(whichPressedD == 3 && whichPressedE ==14){
      drawerPHE();
    }
    else if(whichPressedD == 3 && whichPressedE ==15){
      drawerPRO();
    }
    else if(whichPressedD == 3 && whichPressedE ==16){
      drawerSER();
    }
    else if(whichPressedD == 3 && whichPressedE ==17){
      drawerTHR();
    }
    else if(whichPressedD == 3 && whichPressedE ==18){
      drawerTRP();
    }
    else if(whichPressedD == 3 && whichPressedE ==19){
      drawerTYR();
    }
    else if(whichPressedD == 3 && whichPressedE ==20){
      drawerVAL();
    }
  }

  //VarSetup B
  if(button2.id == whichPressed){

    if(changed){ 
      changed=false; 
      varSetupB();
      if(whichPressedE != 0){
        whichPressedD = 3;
        whichPressedE = 0;
      }

    }
    if(whichPressedD == 4){
      drawer(); 
    }
    else if(whichPressedD == 1){
      drawerJC();
    }
    else if(whichPressedD == 2){
      if(lines[5].equals ("True")){
        drawerJE();
      }
      else{
        textAlign(LEFT);
        fill(255, 100);
        textFont(fontHuge, 30); 
        text("Virus has no envelope.", width/2-160, height/2, 0);
      }
    }
    else if(whichPressedD == 3 && whichPressedE ==0){
      drawerJA();
    }
    else if(whichPressedD == 3 && whichPressedE ==1){
      drawerALA();
    }
    else if(whichPressedD == 3 && whichPressedE ==2){
      drawerARG();
    }
    else if(whichPressedD == 3 && whichPressedE ==3){
      drawerASN();
    }
    else if(whichPressedD == 3 && whichPressedE ==4){
      drawerASP();
    }
    else if(whichPressedD == 3 && whichPressedE ==5){
      drawerCYS();
    }
    else if(whichPressedD == 3 && whichPressedE ==6){
      drawerGLN();
    }
    else if(whichPressedD == 3 && whichPressedE ==7){
      drawerGLU();
    }
    else if(whichPressedD == 3 && whichPressedE ==8){
      drawerGLY();
    }
    else if(whichPressedD == 3 && whichPressedE ==9){
      drawerHIS();
    }
    else if(whichPressedD == 3 && whichPressedE ==10){
      drawerILE();
    }
    else if(whichPressedD == 3 && whichPressedE ==11){
      drawerLEU();
    }
    else if(whichPressedD == 3 && whichPressedE ==12){
      drawerLYS();
    }
    else if(whichPressedD == 3 && whichPressedE ==13){
      drawerMET();
    }
    else if(whichPressedD == 3 && whichPressedE ==14){
      drawerPHE();
    }
    else if(whichPressedD == 3 && whichPressedE ==15){
      drawerPRO();
    }
    else if(whichPressedD == 3 && whichPressedE ==16){
      drawerSER();
    }
    else if(whichPressedD == 3 && whichPressedE ==17){
      drawerTHR();
    }
    else if(whichPressedD == 3 && whichPressedE ==18){
      drawerTRP();
    }
    else if(whichPressedD == 3 && whichPressedE ==19){
      drawerTYR();
    }
    else if(whichPressedD == 3 && whichPressedE ==20){
      drawerVAL();
    }
  }

  //VarSetup C
  if(button3.id == whichPressed){

    if(changed){ 
      changed=false; 
      varSetupC();
      if(whichPressedE != 0){
        whichPressedD = 3;
        whichPressedE = 0;
      }

    }
    if(whichPressedD == 4){
      drawer(); 
    }
    else if(whichPressedD == 1){
      drawerJC();
    }
    else if(whichPressedD == 2){
      if(lines[5].equals ("True")){
        drawerJE();
      }
      else{
        textAlign(LEFT);
        fill(255, 100);
        textFont(fontHuge, 30); 
        text("Virus has no envelope.", width/2-160, height/2, 0);
      }
    }
    else if(whichPressedD == 3 && whichPressedE ==0){
      drawerJA();
    }
    else if(whichPressedD == 3 && whichPressedE ==1){
      drawerALA();
    }
    else if(whichPressedD == 3 && whichPressedE ==2){
      drawerARG();
    }
    else if(whichPressedD == 3 && whichPressedE ==3){
      drawerASN();
    }
    else if(whichPressedD == 3 && whichPressedE ==4){
      drawerASP();
    }
    else if(whichPressedD == 3 && whichPressedE ==5){
      drawerCYS();
    }
    else if(whichPressedD == 3 && whichPressedE ==6){
      drawerGLN();
    }
    else if(whichPressedD == 3 && whichPressedE ==7){
      drawerGLU();
    }
    else if(whichPressedD == 3 && whichPressedE ==8){
      drawerGLY();
    }
    else if(whichPressedD == 3 && whichPressedE ==9){
      drawerHIS();
    }
    else if(whichPressedD == 3 && whichPressedE ==10){
      drawerILE();
    }
    else if(whichPressedD == 3 && whichPressedE ==11){
      drawerLEU();
    }
    else if(whichPressedD == 3 && whichPressedE ==12){
      drawerLYS();
    }
    else if(whichPressedD == 3 && whichPressedE ==13){
      drawerMET();
    }
    else if(whichPressedD == 3 && whichPressedE ==14){
      drawerPHE();
    }
    else if(whichPressedD == 3 && whichPressedE ==15){
      drawerPRO();
    }
    else if(whichPressedD == 3 && whichPressedE ==16){
      drawerSER();
    }
    else if(whichPressedD == 3 && whichPressedE ==17){
      drawerTHR();
    }
    else if(whichPressedD == 3 && whichPressedE ==18){
      drawerTRP();
    }
    else if(whichPressedD == 3 && whichPressedE ==19){
      drawerTYR();
    }
    else if(whichPressedD == 3 && whichPressedE ==20){
      drawerVAL();
    }
  }

  //VarSetup D
  if(button4.id == whichPressed){

    if(changed){ 
      changed=false; 
      varSetupD();
      if(whichPressedE != 0){
        whichPressedD = 3;
        whichPressedE = 0;
      }
    }
    if(whichPressedD == 4){
      drawer(); 
    }
    else if(whichPressedD == 1){
      drawerJC();
    }
    else if(whichPressedD == 2){
      if(lines[5].equals ("True")){
        drawerJE();
      }
      else{
        textAlign(LEFT);
        fill(255, 100);
        textFont(fontHuge, 30); 
        text("Virus has no envelope.", width/2-160, height/2, 0);
      }
    }
    else if(whichPressedD == 3 && whichPressedE ==0){
      drawerJA();
    }
    else if(whichPressedD == 3 && whichPressedE ==1){
      drawerALA();
    }
    else if(whichPressedD == 3 && whichPressedE ==2){
      drawerARG();
    }
    else if(whichPressedD == 3 && whichPressedE ==3){
      drawerASN();
    }
    else if(whichPressedD == 3 && whichPressedE ==4){
      drawerASP();
    }
    else if(whichPressedD == 3 && whichPressedE ==5){
      drawerCYS();
    }
    else if(whichPressedD == 3 && whichPressedE ==6){
      drawerGLN();
    }
    else if(whichPressedD == 3 && whichPressedE ==7){
      drawerGLU();
    }
    else if(whichPressedD == 3 && whichPressedE ==8){
      drawerGLY();
    }
    else if(whichPressedD == 3 && whichPressedE ==9){
      drawerHIS();
    }
    else if(whichPressedD == 3 && whichPressedE ==10){
      drawerILE();
    }
    else if(whichPressedD == 3 && whichPressedE ==11){
      drawerLEU();
    }
    else if(whichPressedD == 3 && whichPressedE ==12){
      drawerLYS();
    }
    else if(whichPressedD == 3 && whichPressedE ==13){
      drawerMET();
    }
    else if(whichPressedD == 3 && whichPressedE ==14){
      drawerPHE();
    }
    else if(whichPressedD == 3 && whichPressedE ==15){
      drawerPRO();
    }
    else if(whichPressedD == 3 && whichPressedE ==16){
      drawerSER();
    }
    else if(whichPressedD == 3 && whichPressedE ==17){
      drawerTHR();
    }
    else if(whichPressedD == 3 && whichPressedE ==18){
      drawerTRP();
    }
    else if(whichPressedD == 3 && whichPressedE ==19){
      drawerTYR();
    }
    else if(whichPressedD == 3 && whichPressedE ==20){
      drawerVAL();
    }
  }
  //VarSetup E
  if(button5.id == whichPressed){

    if(changed){ 
      changed=false; 
      varSetupE();
      if(whichPressedE != 0){
        whichPressedD = 3;
        whichPressedE = 0;
      }
    }
    if(whichPressedD == 4){
      drawer(); 
    }
    else if(whichPressedD == 1){
      drawerJC();
    }
    else if(whichPressedD == 2){
      if(lines[5].equals ("True")){
        drawerJE();
      }
      else{
        textAlign(LEFT);
        fill(255, 100);
        textFont(fontHuge, 30); 
        text("Virus has no envelope.", width/2-160, height/2, 0);
      }
    }
    else if(whichPressedD == 3 && whichPressedE ==0){
      drawerJA();
    }
    else if(whichPressedD == 3 && whichPressedE ==1){
      drawerALA();
    }
    else if(whichPressedD == 3 && whichPressedE ==2){
      drawerARG();
    }
    else if(whichPressedD == 3 && whichPressedE ==3){
      drawerASN();
    }
    else if(whichPressedD == 3 && whichPressedE ==4){
      drawerASP();
    }
    else if(whichPressedD == 3 && whichPressedE ==5){
      drawerCYS();
    }
    else if(whichPressedD == 3 && whichPressedE ==6){
      drawerGLN();
    }
    else if(whichPressedD == 3 && whichPressedE ==7){
      drawerGLU();
    }
    else if(whichPressedD == 3 && whichPressedE ==8){
      drawerGLY();
    }
    else if(whichPressedD == 3 && whichPressedE ==9){
      drawerHIS();
    }
    else if(whichPressedD == 3 && whichPressedE ==10){
      drawerILE();
    }
    else if(whichPressedD == 3 && whichPressedE ==11){
      drawerLEU();
    }
    else if(whichPressedD == 3 && whichPressedE ==12){
      drawerLYS();
    }
    else if(whichPressedD == 3 && whichPressedE ==13){
      drawerMET();
    }
    else if(whichPressedD == 3 && whichPressedE ==14){
      drawerPHE();
    }
    else if(whichPressedD == 3 && whichPressedE ==15){
      drawerPRO();
    }
    else if(whichPressedD == 3 && whichPressedE ==16){
      drawerSER();
    }
    else if(whichPressedD == 3 && whichPressedE ==17){
      drawerTHR();
    }
    else if(whichPressedD == 3 && whichPressedE ==18){
      drawerTRP();
    }
    else if(whichPressedD == 3 && whichPressedE ==19){
      drawerTYR();
    }
    else if(whichPressedD == 3 && whichPressedE ==20){
      drawerVAL();
    }
  }  
  //VarSetup F
  if(button6.id == whichPressed){

    if(changed){ 
      changed=false; 
      varSetupF();
      if(whichPressedE != 0){
        whichPressedD = 3;
        whichPressedE = 0;
      }
    }
    if(whichPressedD == 4){
      drawer(); 
    }
    else if(whichPressedD == 1){
      drawerJC();
    }
    else if(whichPressedD == 2){
      if(lines[5].equals ("True")){
        drawerJE();
      }
      else{
        textAlign(LEFT);
        fill(255, 100);
        textFont(fontHuge, 30); 
        text("Virus has no envelope.", width/2-160, height/2, 0);
      }
    }
    else if(whichPressedD == 3 && whichPressedE ==0){
      drawerJA();
    }
    else if(whichPressedD == 3 && whichPressedE ==1){
      drawerALA();
    }
    else if(whichPressedD == 3 && whichPressedE ==2){
      drawerARG();
    }
    else if(whichPressedD == 3 && whichPressedE ==3){
      drawerASN();
    }
    else if(whichPressedD == 3 && whichPressedE ==4){
      drawerASP();
    }
    else if(whichPressedD == 3 && whichPressedE ==5){
      drawerCYS();
    }
    else if(whichPressedD == 3 && whichPressedE ==6){
      drawerGLN();
    }
    else if(whichPressedD == 3 && whichPressedE ==7){
      drawerGLU();
    }
    else if(whichPressedD == 3 && whichPressedE ==8){
      drawerGLY();
    }
    else if(whichPressedD == 3 && whichPressedE ==9){
      drawerHIS();
    }
    else if(whichPressedD == 3 && whichPressedE ==10){
      drawerILE();
    }
    else if(whichPressedD == 3 && whichPressedE ==11){
      drawerLEU();
    }
    else if(whichPressedD == 3 && whichPressedE ==12){
      drawerLYS();
    }
    else if(whichPressedD == 3 && whichPressedE ==13){
      drawerMET();
    }
    else if(whichPressedD == 3 && whichPressedE ==14){
      drawerPHE();
    }
    else if(whichPressedD == 3 && whichPressedE ==15){
      drawerPRO();
    }
    else if(whichPressedD == 3 && whichPressedE ==16){
      drawerSER();
    }
    else if(whichPressedD == 3 && whichPressedE ==17){
      drawerTHR();
    }
    else if(whichPressedD == 3 && whichPressedE ==18){
      drawerTRP();
    }
    else if(whichPressedD == 3 && whichPressedE ==19){
      drawerTYR();
    }
    else if(whichPressedD == 3 && whichPressedE ==20){
      drawerVAL();
    } 
  }
  //VarSetup G
  if(button7.id == whichPressed){

    if(changed){ 
      changed=false; 
      varSetupG();
      if(whichPressedE != 0){
        whichPressedD = 3;
        whichPressedE = 0;
      }
    }
    if(whichPressedD == 4){
      drawer(); 
    }
    else if(whichPressedD == 1){
      drawerJC();
    }
    else if(whichPressedD == 2){
      if(lines[5].equals ("True")){
        drawerJE();
      }
      else{
        textAlign(LEFT);
        fill(255, 100);
        textFont(fontHuge, 30); 
        text("Virus has no envelope.", width/2-160, height/2, 0);
      }
    }
    else if(whichPressedD == 3 && whichPressedE ==0){
      drawerJA();
    }
    else if(whichPressedD == 3 && whichPressedE ==1){
      drawerALA();
    }
    else if(whichPressedD == 3 && whichPressedE ==2){
      drawerARG();
    }
    else if(whichPressedD == 3 && whichPressedE ==3){
      drawerASN();
    }
    else if(whichPressedD == 3 && whichPressedE ==4){
      drawerASP();
    }
    else if(whichPressedD == 3 && whichPressedE ==5){
      drawerCYS();
    }
    else if(whichPressedD == 3 && whichPressedE ==6){
      drawerGLN();
    }
    else if(whichPressedD == 3 && whichPressedE ==7){
      drawerGLU();
    }
    else if(whichPressedD == 3 && whichPressedE ==8){
      drawerGLY();
    }
    else if(whichPressedD == 3 && whichPressedE ==9){
      drawerHIS();
    }
    else if(whichPressedD == 3 && whichPressedE ==10){
      drawerILE();
    }
    else if(whichPressedD == 3 && whichPressedE ==11){
      drawerLEU();
    }
    else if(whichPressedD == 3 && whichPressedE ==12){
      drawerLYS();
    }
    else if(whichPressedD == 3 && whichPressedE ==13){
      drawerMET();
    }
    else if(whichPressedD == 3 && whichPressedE ==14){
      drawerPHE();
    }
    else if(whichPressedD == 3 && whichPressedE ==15){
      drawerPRO();
    }
    else if(whichPressedD == 3 && whichPressedE ==16){
      drawerSER();
    }
    else if(whichPressedD == 3 && whichPressedE ==17){
      drawerTHR();
    }
    else if(whichPressedD == 3 && whichPressedE ==18){
      drawerTRP();
    }
    else if(whichPressedD == 3 && whichPressedE ==19){
      drawerTYR();
    }
    else if(whichPressedD == 3 && whichPressedE ==20){
      drawerVAL();
    }
  }

  if(button8.id == whichPressed){

    if(changed){ 
      changed=false; 
      varSetupH();
      if(whichPressedE != 0){
        whichPressedD = 3;
        whichPressedE = 0;
      }
    }
    if(whichPressedD == 4){
      drawer(); 
    }
    else if(whichPressedD == 1){
      drawerJC();
    }
    else if(whichPressedD == 2){
      if(lines[5].equals ("True")){
        drawerJE();
      }
      else{
        textAlign(LEFT);
        fill(255, 100);
        textFont(fontHuge, 30); 
        text("Virus has no envelope.", width/2-160, height/2, 0);
      }
    }
    else if(whichPressedD == 3 && whichPressedE ==0){
      drawerJA();
    }
    else if(whichPressedD == 3 && whichPressedE ==1){
      drawerALA();
    }
    else if(whichPressedD == 3 && whichPressedE ==2){
      drawerARG();
    }
    else if(whichPressedD == 3 && whichPressedE ==3){
      drawerASN();
    }
    else if(whichPressedD == 3 && whichPressedE ==4){
      drawerASP();
    }
    else if(whichPressedD == 3 && whichPressedE ==5){
      drawerCYS();
    }
    else if(whichPressedD == 3 && whichPressedE ==6){
      drawerGLN();
    }
    else if(whichPressedD == 3 && whichPressedE ==7){
      drawerGLU();
    }
    else if(whichPressedD == 3 && whichPressedE ==8){
      drawerGLY();
    }
    else if(whichPressedD == 3 && whichPressedE ==9){
      drawerHIS();
    }
    else if(whichPressedD == 3 && whichPressedE ==10){
      drawerILE();
    }
    else if(whichPressedD == 3 && whichPressedE ==11){
      drawerLEU();
    }
    else if(whichPressedD == 3 && whichPressedE ==12){
      drawerLYS();
    }
    else if(whichPressedD == 3 && whichPressedE ==13){
      drawerMET();
    }
    else if(whichPressedD == 3 && whichPressedE ==14){
      drawerPHE();
    }
    else if(whichPressedD == 3 && whichPressedE ==15){
      drawerPRO();
    }
    else if(whichPressedD == 3 && whichPressedE ==16){
      drawerSER();
    }
    else if(whichPressedD == 3 && whichPressedE ==17){
      drawerTHR();
    }
    else if(whichPressedD == 3 && whichPressedE ==18){
      drawerTRP();
    }
    else if(whichPressedD == 3 && whichPressedE ==19){
      drawerTYR();
    }
    else if(whichPressedD == 3 && whichPressedE ==20){
      drawerVAL();
    }
  }

  if(button9.id == whichPressed){

    if(changed){ 
      changed=false; 
      varSetupI();
      if(whichPressedE != 0){
        whichPressedD = 3;
        whichPressedE = 0;
      }
    }
    if(whichPressedD == 4){
      drawer(); 
    }
    else if(whichPressedD == 1){
      drawerJC();
    }
    else if(whichPressedD == 2){
      if(lines[5].equals ("True")){
        drawerJE();
      }
      else{
        textAlign(LEFT);
        fill(255, 100);
        textFont(fontHuge, 30); 
        text("Virus has no envelope.", width/2-160, height/2, 0);
      }
    }
    else if(whichPressedD == 3 && whichPressedE ==0){
      drawerJA();
    }
    else if(whichPressedD == 3 && whichPressedE ==1){
      drawerALA();
    }
    else if(whichPressedD == 3 && whichPressedE ==2){
      drawerARG();
    }
    else if(whichPressedD == 3 && whichPressedE ==3){
      drawerASN();
    }
    else if(whichPressedD == 3 && whichPressedE ==4){
      drawerASP();
    }
    else if(whichPressedD == 3 && whichPressedE ==5){
      drawerCYS();
    }
    else if(whichPressedD == 3 && whichPressedE ==6){
      drawerGLN();
    }
    else if(whichPressedD == 3 && whichPressedE ==7){
      drawerGLU();
    }
    else if(whichPressedD == 3 && whichPressedE ==8){
      drawerGLY();
    }
    else if(whichPressedD == 3 && whichPressedE ==9){
      drawerHIS();
    }
    else if(whichPressedD == 3 && whichPressedE ==10){
      drawerILE();
    }
    else if(whichPressedD == 3 && whichPressedE ==11){
      drawerLEU();
    }
    else if(whichPressedD == 3 && whichPressedE ==12){
      drawerLYS();
    }
    else if(whichPressedD == 3 && whichPressedE ==13){
      drawerMET();
    }
    else if(whichPressedD == 3 && whichPressedE ==14){
      drawerPHE();
    }
    else if(whichPressedD == 3 && whichPressedE ==15){
      drawerPRO();
    }
    else if(whichPressedD == 3 && whichPressedE ==16){
      drawerSER();
    }
    else if(whichPressedD == 3 && whichPressedE ==17){
      drawerTHR();
    }
    else if(whichPressedD == 3 && whichPressedE ==18){
      drawerTRP();
    }
    else if(whichPressedD == 3 && whichPressedE ==19){
      drawerTYR();
    }
    else if(whichPressedD == 3 && whichPressedE ==20){
      drawerVAL();
    }
  }

  if(button10.id == whichPressed){

    if(changed){ 
      changed=false; 
      varSetupJ();
      if(whichPressedE != 0){
        whichPressedD = 3;
        whichPressedE = 0;
      }
    }
    if(whichPressedD == 4){
      drawer(); 
    }
    else if(whichPressedD == 1){
      drawerJC();
    }
    else if(whichPressedD == 2){
      if(lines[5].equals ("True")){
        drawerJE();
      }
      else{
        textAlign(LEFT);
        fill(255, 100);
        textFont(fontHuge, 30); 
        text("Virus has no envelope.", width/2-160, height/2, 0);
      }
    }
    else if(whichPressedD == 3 && whichPressedE ==0){
      drawerJA();
    }
    else if(whichPressedD == 3 && whichPressedE ==1){
      drawerALA();
    }
    else if(whichPressedD == 3 && whichPressedE ==2){
      drawerARG();
    }
    else if(whichPressedD == 3 && whichPressedE ==3){
      drawerASN();
    }
    else if(whichPressedD == 3 && whichPressedE ==4){
      drawerASP();
    }
    else if(whichPressedD == 3 && whichPressedE ==5){
      drawerCYS();
    }
    else if(whichPressedD == 3 && whichPressedE ==6){
      drawerGLN();
    }
    else if(whichPressedD == 3 && whichPressedE ==7){
      drawerGLU();
    }
    else if(whichPressedD == 3 && whichPressedE ==8){
      drawerGLY();
    }
    else if(whichPressedD == 3 && whichPressedE ==9){
      drawerHIS();
    }
    else if(whichPressedD == 3 && whichPressedE ==10){
      drawerILE();
    }
    else if(whichPressedD == 3 && whichPressedE ==11){
      drawerLEU();
    }
    else if(whichPressedD == 3 && whichPressedE ==12){
      drawerLYS();
    }
    else if(whichPressedD == 3 && whichPressedE ==13){
      drawerMET();
    }
    else if(whichPressedD == 3 && whichPressedE ==14){
      drawerPHE();
    }
    else if(whichPressedD == 3 && whichPressedE ==15){
      drawerPRO();
    }
    else if(whichPressedD == 3 && whichPressedE ==16){
      drawerSER();
    }
    else if(whichPressedD == 3 && whichPressedE ==17){
      drawerTHR();
    }
    else if(whichPressedD == 3 && whichPressedE ==18){
      drawerTRP();
    }
    else if(whichPressedD == 3 && whichPressedE ==19){
      drawerTYR();
    }
    else if(whichPressedD == 3 && whichPressedE ==20){
      drawerVAL();
    }
  }

}

public void stop() {
  Ess.stop();
  super.stop();
}
